#include <algorithm>
#include <functional>
#include <iostream>
using namespace std;

class X {
public:
	X(int i) : id(i) { }
	int getId() const { return id; }
	// ...
private:
	const int id;
	// ... weitere Daten
};

struct id_vgl : binary_function<X, int, bool> {
	bool operator()(const X& x, int i) const {
		return x.getId() < i;
	}
};

int main() {
	X x[] = { X(10), X(20), X(30), X(40) };
	X* z = lower_bound(x, x + 4, 25, id_vgl());
	if (z != x + 4)
		cout << z->getId() << endl;
}
