#include <algorithm>
#include <functional>
#include <iostream>
#include <set>
using namespace std;

class Konto {
public:
	Konto(int n, double s = 0.0) : nummer(n), stand(s) { }
	int gibNummer() const { return nummer; }
	double gibStand() const { return stand; }
	void einzahlen(double betrag) { stand += betrag; }
private:
	const int nummer;
	double stand;
};

struct VglKNr : binary_function<Konto, Konto, bool> {
	bool operator()(const Konto& x, const Konto& y) const {
		return x.gibNummer() < y.gibNummer();
	}
};

int main() {
	Konto k[] = { Konto(10, 1.99), Konto(20, 2.98), Konto(30, 3.97) };
	typedef set<Konto, VglKNr> KontoSet;
	KontoSet s(k, k + 3);
	KontoSet::iterator i = s.find(Konto(20));
	if (i != s.end()) {
		const_cast<Konto&>(*i).einzahlen(100.0);
		cout << "Kontostand: " << i->gibStand();
	}
}
