#include <algorithm>
#include <functional>
#include <iostream>
#include <list>
using namespace std;

template<class T>
ostream& operator<<(ostream& os, const list<T>& l) {
	if (l.empty())
		return os << "leer";
	for (typename list<T>::const_iterator i = l.begin(); i != l.end(); ++i)
		os << *i << "  ";
	return os;
}

int main() {
	list<int> a, b;
	for (int i = 1; i < 9; ++i)
		if (i % 2 == 1)
			a.push_front(i);
		else
			b.push_back(i);
	cout << "a = " << a << "und b = " << b << endl;
	a.sort();
	cout << "a = " << a << endl;
	list<int> c(a);
	a.merge(c);  // a mit einer Kopie von a mischen
	cout << "a = " << a << endl;
	a.splice(a.end(), a, a.begin());  // erstes Element an das Ende verschieben
	cout << "a = " << a << endl;
	b.reverse();
	cout << "b = " << b << endl;
	list<int>::iterator b4 = find(b.begin(), b.end(), 4);
	a.splice(a.begin(), b, b4, b.end());
	cout << "a = " << a << "und b = " << b << endl;
	a.splice(a.end(), b);
	cout << "a = " << a << "und b = " << b << endl;
	a.remove(5);
	cout << "a = " << a << endl;
	a.unique();
	cout << "a = " << a << endl;
}
