#ifndef AKTIE_H
#define AKTIE_H

#include "wertpapier.h"

typedef double EUR;

class Aktie : public Wertpapier {
public:
	Aktie(const std::string& kn, const std::string& b, EUR kw, EUR d)
		: Wertpapier(kn, b), kurswert(kw), dividende(d) { }
	EUR gibDividende() const { return dividende; }
	EUR gibKurswert() const { return kurswert; }
protected:
	std::ostream& ausgabe(std::ostream& os) const {
		return Wertpapier::ausgabe(os) << ", Kurswert: " << kurswert
			<< " EUR, Dividende: " << dividende << " EUR";
	}
private:
	EUR kurswert, dividende;
};

#endif
