#ifndef ANLEIHE_H
#define ANLEIHE_H

#include "wertpapier.h"

typedef double Prozent;
typedef std::string Datum;

class Anleihe : public Wertpapier {
public:
	Anleihe(const std::string& kn, const std::string& b, Prozent zs, const Datum& f)
		: Wertpapier(kn, b), zinssatz(zs), faelligkeit(f) { }
	Prozent gibZinssatz() const { return zinssatz; }
	Datum gibFaelligkeit() const { return faelligkeit; }
protected:
	std::ostream& ausgabe(std::ostream& os) const {
		return Wertpapier::ausgabe(os) << ", Zinssatz: " << zinssatz
			<< "%, Flligkeit: " << faelligkeit;
	}
private:
	const Prozent zinssatz;
	const Datum faelligkeit;
};

#endif
