#ifndef SMARTPTR_H
#define SMARTPTR_H

template<class X>
class smart_ptr {
public:
	smart_ptr(X* x = 0) throw() : p(x) { }
	smart_ptr(const smart_ptr& y) throw() : p(y.p) { }
	smart_ptr& operator=(const smart_ptr& y) throw() { p = y.p; return *this; }
	~smart_ptr() throw() { }
	X& operator*() const throw() { return *p; }
	X* operator->() const throw() { return p; }
	X* get() const throw() { return p; }
	operator X*() const throw() { return p; }
	friend bool operator==(const smart_ptr& x, const smart_ptr& y)
		{ return *x.p == *y.p; }
	friend bool operator<(const smart_ptr& x, const smart_ptr& y)
		{ return *x.p < *y.p; }
	// ...
private:
	X* p;
};

#endif
