#ifndef WERTPAPIER_H
#define WERTPAPIER_H

#include <iostream>
#include <string>

class Wertpapier {
public:
	virtual ~Wertpapier() { }
	std::string gibKennNr() const { return kennNr; }
	std::string gibBezeichnung() const { return bezeichnung; }
	friend std::ostream& operator<<(std::ostream& os, const Wertpapier& w)
		{ return w.ausgabe(os); }
	friend bool operator<(const Wertpapier& x, const Wertpapier& y)
		{ return x.kennNr < y.kennNr; }
protected:
	Wertpapier(const std::string& kn, const std::string& b)
		: kennNr(kn), bezeichnung(b) { }
	virtual std::ostream& ausgabe(std::ostream& os) const = 0;
private:
	Wertpapier(const Wertpapier&);
	Wertpapier& operator=(const Wertpapier&);
	const std::string kennNr, bezeichnung;
};

inline std::ostream& Wertpapier::ausgabe(std::ostream& os) const
	{ return os << kennNr << ", " << bezeichnung; }

inline bool operator==(const Wertpapier& x, const Wertpapier& y)
	{ return &x == &y; }

#endif
