template<class T>
class Feld {
public:
	explicit Feld(int groesse = 0) : n(groesse), t(new T[groesse]) { }
	class Iter {
	public:
		Iter(T* cc) : c(cc) { }
		bool operator!=(Iter i) const { return c != i.c; }
		T& operator*() const { return *c; }
		Iter& operator++() { ++c; return *this; }
		// ...
	private:
		T* c;    // Cursor
	};
	Iter start() { return t; }
	Iter ende() { return t + n; }
	// ...
	class Const_Iter {
	public:
		Const_Iter(const T* t) : c(t) { }
		bool operator!=(Const_Iter i) const { return c != i.c; }
		const T& operator*() const { return *c; }
		Const_Iter& operator++() { ++c; return *this; }
	private:
		const T* c;
	};
	Const_Iter start() const { return t; }
	Const_Iter ende() const { return t + n; }
private:
	int n;
	T* t;
};

template<class Iter, class Funktion>
Iter suchen_f(Iter start, Iter ende, Funktion f) {
	while (start != ende && !f(*start)) ++start;
	return start;
}

template<class T>
struct Groesser {
	bool operator()(const T& x, const T& y) const { return x > y; }
};

template<class Operation, class T>
class Binder {
public:
	Binder(const Operation& o, const T& t) : op(o), y(t) { }
	bool operator()(const T& x) const { return op(x, y); }
private:
	const Operation op;
	const T y;
};

template<class Operation, class T> inline 
Binder<Operation, T> binden(const Operation& op, const T& t) {
	return Binder<Operation, T>(op, t);
}

int main() {
	Feld<int> fi(10);
	Feld<int>::Iter i = suchen_f(fi.start(), fi.ende(), binden(Groesser<int>(), 50));
	return i != fi.ende();
}
