#include <algorithm>
#include <iostream>
#include <iterator>
#include <set>
using namespace std;

template<class Container>
class insert_iterator_x
	: public iterator<output_iterator_tag, void, void, void, void> {
public:
	typedef Container container_type;
	explicit insert_iterator_x(Container& x) : container(x) { }
	insert_iterator_x&
		operator=(const typename Container::value_type& value)
			{ container.insert(value); return *this; }
	insert_iterator_x& operator*() { return *this; }
	insert_iterator_x& operator++() { return *this; }
	insert_iterator_x& operator++(int) { return *this; }
protected:
	Container& container;
};

template<class Container> inline
insert_iterator_x<Container> inserter(Container& x)
	{ return insert_iterator_x<Container>(x); }

int main() {
	const int f[] = { 1, 3, 5, 1, 2, 4, 3 };
	multiset<int, greater<int> > ms;
	copy(f, f + 7, inserter(ms));
	copy(ms.begin(), ms.end(), ostream_iterator<int>(cout, "  "));
}
