#include <iostream>
#include <memory>
using namespace std;

class X {
public:
	X(int ii = 0) : i(ii) { cout << "X::X " << this << endl; }
	~X() { cout << "X::~X " << this << endl; }
	void f() { cout << "X::f" << endl; }
	friend ostream& operator<<(ostream& os, const X& x) { return os << x.i; }
private:
	int i;
};

int main() {
	auto_ptr<X> a(new X(1)), b(new X(2));
	a->f();
	b = a;
	cout << *b << endl;
	a.reset(new X(3));
	X* x = a.get();
	x->f();
	X* y = a.release();
	delete y;
}
